package org.apache.bcel.verifier;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;
import javax.swing.ListModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import org.apache.commons.lang3.ArrayUtils;

public class VerifierFactoryListModel implements VerifierFactoryObserver, ListModel<String> {
   private final List<ListDataListener> listeners = new ArrayList();
   private final Set<String> cache = new TreeSet();

   public VerifierFactoryListModel() {
      VerifierFactory.attach(this);
      this.update((String)null);
   }

   public synchronized void addListDataListener(ListDataListener l) {
      this.listeners.add(l);
   }

   public synchronized String getElementAt(int index) {
      return ((String[])this.cache.toArray(ArrayUtils.EMPTY_STRING_ARRAY))[index];
   }

   public synchronized int getSize() {
      return this.cache.size();
   }

   public synchronized void removeListDataListener(ListDataListener l) {
      this.listeners.remove(l);
   }

   public synchronized void update(String s) {
      Verifier[] verifiers = VerifierFactory.getVerifiers();
      int verifierLen = verifiers.length;
      this.cache.clear();
      Verifier[] var4 = verifiers;
      int var5 = verifiers.length;

      for(int var6 = 0; var6 < var5; ++var6) {
         Verifier verifier = var4[var6];
         this.cache.add(verifier.getClassName());
      }

      Iterator var8 = this.listeners.iterator();

      while(var8.hasNext()) {
         ListDataListener listener = (ListDataListener)var8.next();
         listener.contentsChanged(new ListDataEvent(this, 0, 0, verifierLen - 1));
      }

   }
}
